//This is the arduino code for Emily Harmon's MAE 3780 Project Demonstration
//Referenced Code: https://arduinogetstarted.com/tutorials/arduino-keypad
        // https://canvas.cornell.edu/courses/29449/files/4187703?module_item_id=1152867
//THE PASSWORD IS CURENTLY 1234
//USER GUIDE:
  //To start the door unlocking process, press the button once
  //This will let the system know that you are ready to start entering your password
  //Then you can enter the password keypad on the keypad
  //If you aren't sure which keys you pressed, you can check the serial monitor
  //Once you have finished entering the password, press the # key
  //This lets the system know that you have entered the whole password
  //The serial monitor will print whether or not your password is correct 
  //If the password is incorect, the red LED will light up for three seconds
  //If the password is correct, the green LED will blink three times and the servo will rotate to unlock the door
//PROGRAM OVERVIEW
  //The program begins by setting a keyboard and a servo object, and a password
  //The loop begins by waiting for the button to be pressed 
  //Then the program loops to detect the keys that are pressed
  //Once the # key has been pressed, the program compares the entered password to the real password
  //Then the program will tell the user if they were correct and then use the appropriate actuators
#include "Adafruit_Keypad.h"

const byte ROWS = 4; // rows
const byte COLS = 4; // columns
//define the symbols on the buttons of the keypads
char keys[ROWS][COLS] = {
  {'1','2','3','A'},
  {'4','5','6','B'},
  {'7','8','9','C'},
  {'*','0','#','D'}
};
byte rowPins[ROWS] = {5, 4, 3, 2}; //connect to the row pinouts of the keypad
byte colPins[COLS] = {11, 10, 9, 8}; //connect to the column pinouts of the keypad

//initialize an instance of class NewKeypad
Adafruit_Keypad customKeypad = Adafruit_Keypad( makeKeymap(keys), rowPins, colPins, ROWS, COLS);

//Create keypad and servo objects
Keypad keypad = Keypad( makeKeymap(keys), pin_rows, pin_column, ROW_NUM, COLUMN_NUM );
Servo myservo;  

//Make the password to unlock the door
const String password = "1234"; // this is where you can change the password if you want to!
String input_password;

void setup(){
  Serial.begin(9600);
   customKeypad.begin();

}
void setup() {
  Serial.begin(9600);
  customKeypad.begin();
}

void loop(){
  char key = keypad.getKey(); //variable that stores which key the user has pressed

  if (digitalRead(2) == HIGH) { //if the button is pressed
      input_password = ""; // clear input password
      Serial.println("Begin entering password"); //this doesn't display and I don't understand why!!!
       while (key != '#') {     //loop until the pound key has been pressed
           key = keypad.getKey();
           if (key != NO_KEY && key != '#'){    
              input_password += key; // append new character to input password string
            Serial.println(key); //print the character of the keys pressed to the serial monitor so you know which keys you pressed
          }
          }
    
      //the while loop ending signifies that the user is done entering the password
      //now we need to compare the entered password to the actual password
        if(password == input_password) {  //if the user is correct
          //Let the user know their password attempt was correct
          Serial.println("Password is correct, door will now unlock"); 
          delay(1000);
          //Blink green LED three times
            for (int i=1; i <= 3; i++) {
            digitalWrite(13, HIGH);
            delay(300);
            digitalWrite(13, LOW);
            delay(300);
            }
            delay(1000); //one more delay so that the process is easier to observe
          //Use the arduino to unlock the door
      myservo.attach(11); // tell the Arduino which pin will drive the servo- I am doing this later than setup in case the user opens the door two+ times in one simulation
          myservo.write(90); //the servo begins rotating in the clockwise direction at a low speed to unlock the door
          delay(2000); //duration of time the servo rotates for
          myservo.write(95); //then the servo reverses directions, this doesn't relock the door. But it does give tension in the string so that the user can manually relock the door once they have entered
          delay(2000); //duration of time the servo rotates for
          myservo.detach(); //makes the servo stop by detaching servo from arduino to prevent “creeping” effect 
        
      } else { //What happens when the entered password is incorrect
        //Let the user know their password was wrong
        Serial.println("Password is incorrect, try again");
        //Turn red LED on
        digitalWrite(12, HIGH);
        delay(1000);
        digitalWrite(12, LOW);
      }
      input_password = ""; // clear input password
   }
}
